#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>
#include "test_vector.h"

int main(int argc, char **argv)
{
     unsigned long i, tot;
     unsigned long n = INITIAL_DIM;

     FILE *fp1, *fp2;
     int n_test = 0;
	
     if(argc < 3)
     {
	  printf("Devi inserire il nome dei due file\n");
	  exit(1);
     }

     srand(time(NULL));
     fp1 = fopen(argv[1], "r");
     fp2 = fopen(argv[2], "r");
     while(n <= MAX_DIM)
     {
	  char buff1[33];
	  char buff2[33];
	  unsigned long result1, result2;
	  int len;
	  n_test++;
	  tot = 0;
	  for(i = 0; i < n; i++)
	  {

	       fgets(buff1, 33, fp1);
	       fgets(buff2, 33, fp2);
	       buff1[1] = '\0';
	       buff2[1] = '\0';
	       
	       if(strcmp(buff1, buff2) == 0)
	       {
		    if(strcmp(buff1, "1") == 0)
		    {
			 tot++;
		    }
	       }
	       printf("%s,%s ", buff1, buff2);
	       if(((i + 1) % 20) == 0) printf("\n");
	  }
	  fgets(buff1, 33, fp1);
	  fgets(buff2, 33, fp2);
	  len = strlen(buff1);
	  if(buff1[len-1] == '\n')
	  {
	        buff1[len-1] = '\0';
	  }
	  len = strlen(buff2);
	  if(buff2[len-1] == '\n')
	  {
	       buff2[len-1] = '\0';
	  }
	  sscanf(buff1, "%lu",&result1);
	  sscanf(buff2, "%lu",&result2);
	  printf("Test [%d]; n = [%lu]; result = [%lu]\n", n_test, n, tot);
	  if((result1 == result2) && (result1 == tot))
	  {
	       printf("[ok]\n");
	  }
	  else
	  {
	       printf("[failed]\n");
	  }
	  printf("\n");
	  n+=DELTA_DIM;
     }
     fclose(fp1);
     fclose(fp2);

     return 0;
}
