#include <openssl/bn.h>
#include <openssl/rsa.h>
#include <openssl/rand.h>

#define PUBLIC_EXPONENT 3
#define MODULUS_SIZE 1024

RSA *RSA_generate_key_commutative(int bits, BIGNUM *p_value, BIGNUM *q_value); 
RSA *RSA_gen_key();
RSA *RSA_gen_key_commutative(RSA *common_key);
int write_rsa_keys(char *pubname, char *privname, RSA *rsa, char *password);
void print_values(RSA *rsa);
int calculate_size(char *pub_key_file, int length);
unsigned char *rsa_encrypt1(char *pub_key_file, char *from, int length);
unsigned char *rsa_encrypt2(char *pub_key_file, unsigned char *from, int length);
int rsa_decrypt(char *priv_key_file, unsigned char *from, unsigned char *to, 
		int size, char *password);
void init_ssl();
