#include <openssl/ssl.h>
#include <openssl/x509.h>
#include <openssl/rand.h>
#include <openssl/err.h>
#include <openssl/evp.h>

void print_ssl_error(char *func_name, char *ssl_func);
void ssl_get_error(SSL *ssl, int ret, char* func_name, char *ssl_func);
void ssl_init();
void ssl_end();
SSL_CTX* ssl_setup_ctx_client(char *certfile, char *certificate, char *privkey);
SSL_CTX *ssl_setup_ctx_server(char *certfile, char *certificate, char *privkey);
