#!/bin/sh
if [ $# -ne 1 ]
then
	echo "Usage: $0 ipfile"
	exit 1
fi
`rm -f CAfile.pem`
lines=`wc -l $1 | cut -c1-8`
lines=`expr $lines + 0`
while [ $lines -ge 1 ]
do
  ip=`head -$lines $1 | tail -1`
  echo "----------Creating RSA keys for ip ${ip}----------"
  `openssl req -config openssl.cnf -newkey rsa:512 -days 1000 -nodes -keyout ${ip}.private.pem -out ${ip}.certificate.pem -x509 -new`
  `openssl x509 -in ${ip}.certificate.pem -text >> CAfile.pem`
  lines=`expr $lines - 1`
done




